/* read_ppm.c 
 * Copyright (C) 2001 by The matterial Developers 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <stdlib.h>
#include <glib.h>

#include "lut.h"

/*====================================================*/
void UsagePPM()
{
}

/*====================================================*/
int RecPPM(char *filename, int argc, char **argv)
{
	char line[3];
	FILE *fid;

	fid = fopen(filename, "r");
	if (!fid) 	
	{
		fprintf(stderr, "cannot open %s\n", filename);
		return 0;
	}

	memset(line, 0, 3);
	fread(line, 2,  1, fid);
	fclose(fid);


	return (!strcmp(line, "P6"));
}
/*====================================================*/
/* returns 1 on sucess                                */
int ReadPPM(char *filename, int *w, int *h, unsigned char **buf,
		int argc, char **argv, lut_t *lut)
{
	int size, a, b;
	FILE *fid;
	char line[300];
	unsigned char *inbuf;

	fid = fopen(filename, "r");
	if (!fid) 	
	{
		fprintf(stderr, "cannot open %s\n", filename);
		return 0;
	}

	fgets(line, 300, fid);
	line[0] = '#';
	while (line[0] == '#')
		fgets(line, 300, fid);
	sscanf(line, "%d %d", w, h);
	size = (*w) * (*h);
	fgets(line, 300, fid);

	*buf = (unsigned char *)malloc(4*size);
	memset(*buf, 0, 4*size);

	inbuf = (unsigned char *)malloc(3*size);
	if (fread(inbuf, 1, 3*size, fid) != 3*size)
		return 0;

	b = 0;
	for (a=0; a<size; a++)
	{
		if (G_BYTE_ORDER == G_LITTLE_ENDIAN)
		{
			(*buf)[b]	= lut->lut8[inbuf[3*a+2]];
			(*buf)[b+1]	= lut->lut8[inbuf[3*a+1]];
			(*buf)[b+2]	= lut->lut8[inbuf[3*a]];
			(*buf)[b+3]	= 255;
		}
		else
		{
			(*buf)[b+1]	= lut->lut8[inbuf[3*a+2]];
			(*buf)[b+2]	= lut->lut8[inbuf[3*a+1]];
			(*buf)[b+3]	= lut->lut8[inbuf[3*a]];
			(*buf)[b]	= 255;
		}
		b += 4;
	}	
	
	fclose(fid);
	free(inbuf);

	return 1;
}
